//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#define MAXCHANNELNAMELEN 50
#define MAXTOPICLEN 300
#define MAXBANSPERCHAN 50
struct weircd_channelban {
	unsigned char* actor;
	unsigned char* mask;
	long time;
};
struct weircd_channel {
	unsigned char name[MAXCHANNELNAMELEN + 1];
	unsigned char topic[MAXTOPICLEN + 1];
	unsigned char topic_setby[50];
	long topic_settime;
	struct weircd_channelban* ban[MAXBANSPERCHAN];
	bool mode_moderated;
	bool mode_topiclock;
	bool mode_registered;
	bool mode_inviteonly;
	bool mode_ircopsonly;
	bool mode_blockcolours;
	bool mode_private;
	bool isregistered;
	int userlimit;
	unsigned char* password;
};
struct weircd_channel* chans[COMPILEOPTION_MAXCHANS];
void weircdChannelsInit() {
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		chans[r] = NULL;
		r += 1;
	}
}
int getChanID(const unsigned char* channame) {
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		if (chans[r] != NULL) {
			if (strcasecmp(chans[r]->name,channame) == 0) {
				return r;
			}
		}
		r += 1;
	}
	return -1;
}
int addChan(const unsigned char* channame) {
	int r = getChanID(channame);
	if (r >= 0) {return r;}
	r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		if (chans[r] == NULL) {
			chans[r] = malloc(sizeof(struct weircd_channel));
			if (chans[r] != NULL) {
				memset(chans[r],0,sizeof(struct weircd_channel));
				strcpy(chans[r]->name,channame);
#ifdef SERVICES_ENABLED
				unsigned char *co;
				if (cuo.services_activated == 1) {
					if (chanregistered(channame) == true) {
						chans[r]->mode_registered = true;
						co = services_chanorigname(channame);
						if (co != NULL) {
							if (strcasecmp(co,"") != 0) {
								strcpy(chans[r]->name,co);
							}
							free(co);
						}
						co = services_chantopic(channame);
						if (co != NULL) {
							strcpy(chans[r]->topic,co);
							strcpy(chans[r]->topic_setby,"ChanServ");
							chans[r]->topic_settime = time(NULL);
						}
					}
				}
#endif
				return r;
			}
		}
		r += 1;
	}
	return -1;
}
unsigned char* cn(const unsigned char* vcn) {
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		if (chans[r] != NULL) {
			if (strcasecmp(chans[r]->name,vcn) == 0) {
				return chans[r]->name;
			}
		}
		r += 1;
	}
	return NULL;
}
